diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/visualizer/model/pyviz.cc ns-3.47/src/visualizer/model/pyviz.cc
--- ns-3.46/src/visualizer/model/pyviz.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/visualizer/model/pyviz.cc	2026-02-16 16:08:49.842230800 -0800
@@ -8,12 +8,15 @@
 
 #include "pyviz.h"
 
+#include "fast-clipping.h"
 #include "visual-simulator-impl.h"
 
 #include "ns3/abort.h"
 #include "ns3/config.h"
 #include "ns3/ethernet-header.h"
 #include "ns3/log.h"
+#include "ns3/lr-wpan-mac-header.h"
+#include "ns3/lr-wpan-net-device.h"
 #include "ns3/node-list.h"
 #include "ns3/ppp-header.h"
 #include "ns3/simulator.h"
@@ -23,9 +26,9 @@
 #include <cstdlib>
 #include <sstream>
 
-NS_LOG_COMPONENT_DEFINE("PyViz");
+using namespace ns3::lrwpan;
 
-#define NUM_LAST_PACKETS 10
+NS_LOG_COMPONENT_DEFINE("PyViz");
 
 static std::vector<std::string>
 PathSplit(std::string str)
@@ -50,6 +53,9 @@
 namespace ns3
 {
 
+namespace visualizer
+{
+
 static PyViz* g_visualizer = nullptr; ///< the visualizer
 
 /**
@@ -75,7 +81,8 @@
 TypeId
 PyVizPacketTag::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::PyVizPacketTag")
+    static TypeId tid = TypeId("ns3::visualizer::PyVizPacketTag")
+                            .AddDeprecatedName("ns3::PyVizPacketTag")
                             .SetParent<Tag>()
                             .SetGroupName("Visualizer")
                             .AddConstructor<PyVizPacketTag>();
@@ -129,6 +136,12 @@
 
     Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/MacRx",
                             MakeCallback(&PyViz::TraceNetDevRxWifi, this));
+    // Lr-Wpan
+    Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::lrwpan::LrWpanNetDevice/Mac/MacTx",
+                            MakeCallback(&PyViz::TraceNetDevTxLrWpan, this));
+
+    Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::lrwpan::LrWpanNetDevice/Mac/MacRx",
+                            MakeCallback(&PyViz::TraceNetDevRxLrWpan, this));
 
     // CSMA
     Config::ConnectFailSafe("/NodeList/*/DeviceList/*/$ns3::CsmaNetDevice/MacTx",
@@ -263,7 +276,7 @@
     NS_LOG_FUNCTION_NOARGS();
     if (m_runUntil <= Simulator::Now())
     {
-        Simulator::Stop(Seconds(0)); // Stop right now
+        Simulator::Stop(); // Stop right now
         m_stop = true;
     }
 }
@@ -309,6 +322,7 @@
     {
         return;
     }
+
     // Schedule a dummy callback function for the target time, to make
     // sure we stop at the right time.  Otherwise, simulations with few
     // events just appear to "jump" big chunks of time.
@@ -332,6 +346,14 @@
     }
 }
 
+Time
+PyViz::GetSimulatorStopTime()
+{
+    Ptr<SimulatorImpl> impl = Simulator::GetImplementation();
+    Ptr<VisualSimulatorImpl> visualImpl = DynamicCast<VisualSimulatorImpl>(impl);
+    return visualImpl->GetStopTime();
+}
+
 bool
 PyViz::TransmissionSampleKey::operator<(const PyViz::TransmissionSampleKey& other) const
 {
@@ -362,7 +384,7 @@
     return retval;
 }
 
-PyViz::NetDeviceStatistics&
+NetDeviceStatistics&
 PyViz::FindNetDeviceStatistics(int node, int interface)
 {
     auto nodeStatsIter = m_nodesStatistics.find(node);
@@ -500,9 +522,10 @@
 // --------- TX device tracing -------------------
 
 void
-PyViz::TraceNetDevTxCommon(const std::string& context,
-                           Ptr<const Packet> packet,
-                           const Mac48Address& destinationAddress)
+PyViz::TraceNetDevTxCommon(
+    const std::string& context,
+    Ptr<const Packet> packet,
+    const std::variant<Mac16Address, Mac48Address, Mac64Address>& destination)
 {
     NS_LOG_FUNCTION(context << packet->GetUid() << *packet);
 
@@ -527,7 +550,8 @@
         lastPacket.time = Simulator::Now();
         lastPacket.packet = packet->Copy();
         lastPacket.device = device;
-        lastPacket.to = destinationAddress;
+        lastPacket.to = destination;
+
         last.lastTransmittedPackets.push_back(lastPacket);
         while (last.lastTransmittedPackets.size() > captureOptions->numLastPackets)
         {
@@ -554,9 +578,29 @@
     }
 
     TxRecordValue record = {Simulator::Now(), node, false};
-    if (destinationAddress == device->GetBroadcast())
+
+    if (std::holds_alternative<Mac16Address>(destination))
+    {
+        if (std::get<Mac16Address>(destination) == Mac16Address("FF:FF"))
+        {
+            record.isBroadcast = true;
+        }
+    }
+    else if (std::holds_alternative<Mac48Address>(destination))
     {
-        record.isBroadcast = true;
+        if (std::get<Mac48Address>(destination) == device->GetBroadcast())
+        {
+            record.isBroadcast = true;
+        }
+    }
+    else if (std::holds_alternative<Mac64Address>(destination))
+    {
+        if (std::get<Mac64Address>(destination) == Mac64Address("FF:FF:FF:FF:FF:FF:FF:FF"))
+        {
+            // Note: A broadcast using th the MAC 64 bit address is not really used in practice.
+            // instead the 16 bit MAC address is used.
+            record.isBroadcast = true;
+        }
     }
 
     m_txRecords[TxRecordKey(device->GetChannel(), packet->GetUid())] = record;
@@ -582,7 +626,8 @@
      */
     WifiMacHeader hdr;
     NS_ABORT_IF(packet->PeekHeader(hdr) == 0);
-    Mac48Address destinationAddress;
+
+    std::variant<Mac16Address, Mac48Address, Mac64Address> destinationAddress;
     if (hdr.IsToDs())
     {
         destinationAddress = hdr.GetAddr3();
@@ -595,17 +640,41 @@
 }
 
 void
+PyViz::TraceNetDevTxLrWpan(std::string context, Ptr<const Packet> packet)
+{
+    LrWpanMacHeader hdr;
+    NS_ABORT_IF(packet->PeekHeader(hdr) == 0);
+    std::variant<Mac16Address, Mac48Address, Mac64Address> destinationAddress;
+
+    switch (hdr.GetDstAddrMode())
+    {
+    case lrwpan::AddressMode::EXT_ADDR:
+        destinationAddress = hdr.GetExtDstAddr();
+        break;
+    default:
+        destinationAddress = hdr.GetShortDstAddr();
+        break;
+    }
+
+    TraceNetDevTxCommon(context, packet, destinationAddress);
+}
+
+void
 PyViz::TraceNetDevTxCsma(std::string context, Ptr<const Packet> packet)
 {
     EthernetHeader ethernetHeader;
     NS_ABORT_IF(packet->PeekHeader(ethernetHeader) == 0);
-    TraceNetDevTxCommon(context, packet, ethernetHeader.GetDestination());
+    std::variant<Mac16Address, Mac48Address, Mac64Address> destinationAddress;
+    destinationAddress = ethernetHeader.GetDestination();
+    TraceNetDevTxCommon(context, packet, destinationAddress);
 }
 
 void
 PyViz::TraceNetDevTxPointToPoint(std::string context, Ptr<const Packet> packet)
 {
-    TraceNetDevTxCommon(context, packet, Mac48Address());
+    std::variant<Mac16Address, Mac48Address, Mac64Address> destinationAddress;
+    destinationAddress = Mac48Address();
+    TraceNetDevTxCommon(context, packet, destinationAddress);
 }
 
 // --------- RX device tracing -------------------
@@ -613,7 +682,7 @@
 void
 PyViz::TraceNetDevRxCommon(const std::string& context,
                            Ptr<const Packet> packet,
-                           const Mac48Address& from)
+                           const std::variant<Mac16Address, Mac48Address, Mac64Address>& source)
 {
     uint32_t uid;
     PyVizPacketTag tag;
@@ -651,7 +720,8 @@
         lastPacket.time = Simulator::Now();
         lastPacket.packet = packet->Copy();
         lastPacket.device = device;
-        lastPacket.from = from;
+        lastPacket.from = source;
+
         last.lastReceivedPackets.push_back(lastPacket);
         while (last.lastReceivedPackets.size() > captureOptions->numLastPackets)
         {
@@ -742,7 +812,7 @@
      */
     WifiMacHeader hdr;
     NS_ABORT_IF(packet->PeekHeader(hdr) == 0);
-    Mac48Address sourceAddress;
+    std::variant<Mac16Address, Mac48Address, Mac64Address> sourceAddress;
     if (!hdr.IsFromDs())
     {
         sourceAddress = hdr.GetAddr2();
@@ -760,17 +830,40 @@
 }
 
 void
+PyViz::TraceNetDevRxLrWpan(std::string context, Ptr<const Packet> packet)
+{
+    LrWpanMacHeader hdr;
+    NS_ABORT_IF(packet->PeekHeader(hdr) == 0);
+    std::variant<Mac16Address, Mac48Address, Mac64Address> sourceAddress;
+    switch (hdr.GetSrcAddrMode())
+    {
+    case lrwpan::AddressMode::EXT_ADDR:
+        sourceAddress = hdr.GetExtSrcAddr();
+        break;
+    default:
+        sourceAddress = hdr.GetShortSrcAddr();
+        break;
+    }
+
+    TraceNetDevRxCommon(context, packet, sourceAddress);
+}
+
+void
 PyViz::TraceNetDevRxCsma(std::string context, Ptr<const Packet> packet)
 {
     EthernetHeader ethernetHeader;
     NS_ABORT_IF(packet->PeekHeader(ethernetHeader) == 0);
-    TraceNetDevRxCommon(context, packet, ethernetHeader.GetSource());
+    std::variant<Mac16Address, Mac48Address, Mac64Address> sourceAddress;
+    sourceAddress = ethernetHeader.GetSource();
+    TraceNetDevRxCommon(context, packet, sourceAddress);
 }
 
 void
 PyViz::TraceNetDevRxPointToPoint(std::string context, Ptr<const Packet> packet)
 {
-    TraceNetDevRxCommon(context, packet, Mac48Address());
+    std::variant<Mac16Address, Mac48Address, Mac64Address> sourceAddress;
+    sourceAddress = Mac48Address();
+    TraceNetDevRxCommon(context, packet, sourceAddress);
 }
 
 void
@@ -785,7 +878,9 @@
     // TraceNetDevRxCsma; we don't want to receive them twice.
     if (packetType == NetDevice::PACKET_OTHERHOST)
     {
-        TraceNetDevRxCommon(context, packet, ethernetHeader.GetDestination());
+        std::variant<Mac16Address, Mac48Address, Mac64Address> destinationAddress;
+        destinationAddress = ethernetHeader.GetDestination();
+        TraceNetDevRxCommon(context, packet, destinationAddress);
     }
 }
 
@@ -795,19 +890,23 @@
                         const Mac48Address& destination)
 {
     NS_LOG_FUNCTION(context);
-    TraceNetDevTxCommon(context, packet, destination);
+    std::variant<Mac16Address, Mac48Address, Mac64Address> destinationAddress;
+    destinationAddress = destination;
+    TraceNetDevTxCommon(context, packet, destinationAddress);
 }
 
 void
 PyViz::TraceNetDevRxLte(std::string context, Ptr<const Packet> packet, const Mac48Address& source)
 {
     NS_LOG_FUNCTION(context);
-    TraceNetDevRxCommon(context, packet, source);
+    std::variant<Mac16Address, Mac48Address, Mac64Address> sourceAddress;
+    sourceAddress = source;
+    TraceNetDevRxCommon(context, packet, sourceAddress);
 }
 
 // ---------------------
 
-PyViz::TransmissionSampleList
+TransmissionSampleList
 PyViz::GetTransmissionSamples() const
 {
     NS_LOG_DEBUG("GetTransmissionSamples BEGIN");
@@ -827,7 +926,7 @@
     return list;
 }
 
-PyViz::PacketDropSampleList
+PacketDropSampleList
 PyViz::GetPacketDropSamples() const
 {
     NS_LOG_DEBUG("GetPacketDropSamples BEGIN");
@@ -851,10 +950,10 @@
     m_nodesOfInterest = nodes;
 }
 
-std::vector<PyViz::NodeStatistics>
+std::vector<NodeStatistics>
 PyViz::GetNodesStatistics() const
 {
-    std::vector<PyViz::NodeStatistics> retval;
+    std::vector<NodeStatistics> retval;
     for (auto iter = m_nodesStatistics.begin(); iter != m_nodesStatistics.end(); iter++)
     {
         NodeStatistics stats = {iter->first, iter->second};
@@ -863,7 +962,7 @@
     return retval;
 }
 
-PyViz::LastPacketsSample
+LastPacketsSample
 PyViz::GetLastPackets(uint32_t nodeId) const
 {
     NS_LOG_DEBUG("GetLastPackets: " << nodeId);
@@ -879,679 +978,6 @@
     }
 }
 
-namespace
-{
-/// Adapted from http://en.wikipedia.org/w/index.php?title=Line_clipping&oldid=248609574
-class FastClipping
-{
-  public:
-    /// Vector2 structure
-    struct Vector2
-    {
-        double x; ///< X
-        double y; ///< Y
-    };
-
-    Vector2 m_clipMin; ///< clip minimum
-    Vector2 m_clipMax; ///< clip maximum
-
-    /// Line structure
-    struct Line
-    {
-        Vector2 start; ///< start
-        Vector2 end;   ///<  end
-        double dx;     ///< dX
-        double dy;     ///< dY
-    };
-
-  private:
-    /**
-     * Clip start top function
-     * @param line the clip line
-     */
-    void ClipStartTop(Line& line) const
-    {
-        line.start.x += line.dx * (m_clipMin.y - line.start.y) / line.dy;
-        line.start.y = m_clipMin.y;
-    }
-
-    /**
-     * Clip start bottom function
-     * @param line the clip line
-     */
-    void ClipStartBottom(Line& line) const
-    {
-        line.start.x += line.dx * (m_clipMax.y - line.start.y) / line.dy;
-        line.start.y = m_clipMax.y;
-    }
-
-    /**
-     * Clip start right function
-     * @param line the clip line
-     */
-    void ClipStartRight(Line& line) const
-    {
-        line.start.y += line.dy * (m_clipMax.x - line.start.x) / line.dx;
-        line.start.x = m_clipMax.x;
-    }
-
-    /**
-     * Clip start left function
-     * @param line the clip line
-     */
-    void ClipStartLeft(Line& line) const
-    {
-        line.start.y += line.dy * (m_clipMin.x - line.start.x) / line.dx;
-        line.start.x = m_clipMin.x;
-    }
-
-    /**
-     * Clip end top function
-     * @param line the clip line
-     */
-    void ClipEndTop(Line& line) const
-    {
-        line.end.x += line.dx * (m_clipMin.y - line.end.y) / line.dy;
-        line.end.y = m_clipMin.y;
-    }
-
-    /**
-     * Clip end bottom function
-     * @param line the clip line
-     */
-    void ClipEndBottom(Line& line) const
-    {
-        line.end.x += line.dx * (m_clipMax.y - line.end.y) / line.dy;
-        line.end.y = m_clipMax.y;
-    }
-
-    /**
-     * Clip end right function
-     * @param line the clip line
-     */
-    void ClipEndRight(Line& line) const
-    {
-        line.end.y += line.dy * (m_clipMax.x - line.end.x) / line.dx;
-        line.end.x = m_clipMax.x;
-    }
-
-    /**
-     * Clip end left function
-     * @param line the clip line
-     */
-    void ClipEndLeft(Line& line) const
-    {
-        line.end.y += line.dy * (m_clipMin.x - line.end.x) / line.dx;
-        line.end.x = m_clipMin.x;
-    }
-
-  public:
-    /**
-     * Constructor
-     *
-     * @param clipMin minimum clipping vector
-     * @param clipMax maximum clipping vector
-     */
-    FastClipping(Vector2 clipMin, Vector2 clipMax)
-        : m_clipMin(clipMin),
-          m_clipMax(clipMax)
-    {
-    }
-
-    /**
-     * Clip line function
-     * @param line the clip line
-     * @returns true if clipped
-     */
-    bool ClipLine(Line& line)
-    {
-        uint8_t lineCode = 0;
-
-        if (line.end.y < m_clipMin.y)
-        {
-            lineCode |= 8;
-        }
-        else if (line.end.y > m_clipMax.y)
-        {
-            lineCode |= 4;
-        }
-
-        if (line.end.x > m_clipMax.x)
-        {
-            lineCode |= 2;
-        }
-        else if (line.end.x < m_clipMin.x)
-        {
-            lineCode |= 1;
-        }
-
-        if (line.start.y < m_clipMin.y)
-        {
-            lineCode |= 128;
-        }
-        else if (line.start.y > m_clipMax.y)
-        {
-            lineCode |= 64;
-        }
-
-        if (line.start.x > m_clipMax.x)
-        {
-            lineCode |= 32;
-        }
-        else if (line.start.x < m_clipMin.x)
-        {
-            lineCode |= 16;
-        }
-
-        // 9 - 8 - A
-        // |   |   |
-        // 1 - 0 - 2
-        // |   |   |
-        // 5 - 4 - 6
-        switch (lineCode)
-        {
-        // center
-        case 0x00:
-            return true;
-
-        case 0x01:
-            ClipEndLeft(line);
-            return true;
-
-        case 0x02:
-            ClipEndRight(line);
-            return true;
-
-        case 0x04:
-            ClipEndBottom(line);
-            return true;
-
-        case 0x05:
-            ClipEndLeft(line);
-            if (line.end.y > m_clipMax.y)
-            {
-                ClipEndBottom(line);
-            }
-            return true;
-
-        case 0x06:
-            ClipEndRight(line);
-            if (line.end.y > m_clipMax.y)
-            {
-                ClipEndBottom(line);
-            }
-            return true;
-
-        case 0x08:
-            ClipEndTop(line);
-            return true;
-
-        case 0x09:
-            ClipEndLeft(line);
-            if (line.end.y < m_clipMin.y)
-            {
-                ClipEndTop(line);
-            }
-            return true;
-
-        case 0x0A:
-            ClipEndRight(line);
-            if (line.end.y < m_clipMin.y)
-            {
-                ClipEndTop(line);
-            }
-            return true;
-
-        // left
-        case 0x10:
-            ClipStartLeft(line);
-            return true;
-
-        case 0x12:
-            ClipStartLeft(line);
-            ClipEndRight(line);
-            return true;
-
-        case 0x14:
-            ClipStartLeft(line);
-            if (line.start.y > m_clipMax.y)
-            {
-                return false;
-            }
-            ClipEndBottom(line);
-            return true;
-
-        case 0x16:
-            ClipStartLeft(line);
-            if (line.start.y > m_clipMax.y)
-            {
-                return false;
-            }
-            ClipEndBottom(line);
-            if (line.end.x > m_clipMax.x)
-            {
-                ClipEndRight(line);
-            }
-            return true;
-
-        case 0x18:
-            ClipStartLeft(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                return false;
-            }
-            ClipEndTop(line);
-            return true;
-
-        case 0x1A:
-            ClipStartLeft(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                return false;
-            }
-            ClipEndTop(line);
-            if (line.end.x > m_clipMax.x)
-            {
-                ClipEndRight(line);
-            }
-            return true;
-
-        // right
-        case 0x20:
-            ClipStartRight(line);
-            return true;
-
-        case 0x21:
-            ClipStartRight(line);
-            ClipEndLeft(line);
-            return true;
-
-        case 0x24:
-            ClipStartRight(line);
-            if (line.start.y > m_clipMax.y)
-            {
-                return false;
-            }
-            ClipEndBottom(line);
-            return true;
-
-        case 0x25:
-            ClipStartRight(line);
-            if (line.start.y > m_clipMax.y)
-            {
-                return false;
-            }
-            ClipEndBottom(line);
-            if (line.end.x < m_clipMin.x)
-            {
-                ClipEndLeft(line);
-            }
-            return true;
-
-        case 0x28:
-            ClipStartRight(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                return false;
-            }
-            ClipEndTop(line);
-            return true;
-
-        case 0x29:
-            ClipStartRight(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                return false;
-            }
-            ClipEndTop(line);
-            if (line.end.x < m_clipMin.x)
-            {
-                ClipEndLeft(line);
-            }
-            return true;
-
-        // bottom
-        case 0x40:
-            ClipStartBottom(line);
-            return true;
-
-        case 0x41:
-            ClipStartBottom(line);
-            if (line.start.x < m_clipMin.x)
-            {
-                return false;
-            }
-            ClipEndLeft(line);
-            if (line.end.y > m_clipMax.y)
-            {
-                ClipEndBottom(line);
-            }
-            return true;
-
-        case 0x42:
-            ClipStartBottom(line);
-            if (line.start.x > m_clipMax.x)
-            {
-                return false;
-            }
-            ClipEndRight(line);
-            return true;
-
-        case 0x48:
-            ClipStartBottom(line);
-            ClipEndTop(line);
-            return true;
-
-        case 0x49:
-            ClipStartBottom(line);
-            if (line.start.x < m_clipMin.x)
-            {
-                return false;
-            }
-            ClipEndLeft(line);
-            if (line.end.y < m_clipMin.y)
-            {
-                ClipEndTop(line);
-            }
-            return true;
-
-        case 0x4A:
-            ClipStartBottom(line);
-            if (line.start.x > m_clipMax.x)
-            {
-                return false;
-            }
-            ClipEndRight(line);
-            if (line.end.y < m_clipMin.y)
-            {
-                ClipEndTop(line);
-            }
-            return true;
-
-        // bottom-left
-        case 0x50:
-            ClipStartLeft(line);
-            if (line.start.y > m_clipMax.y)
-            {
-                ClipStartBottom(line);
-            }
-            return true;
-
-        case 0x52:
-            ClipEndRight(line);
-            if (line.end.y > m_clipMax.y)
-            {
-                return false;
-            }
-            ClipStartBottom(line);
-            if (line.start.x < m_clipMin.x)
-            {
-                ClipStartLeft(line);
-            }
-            return true;
-
-        case 0x58:
-            ClipEndTop(line);
-            if (line.end.x < m_clipMin.x)
-            {
-                return false;
-            }
-            ClipStartBottom(line);
-            if (line.start.x < m_clipMin.x)
-            {
-                ClipStartLeft(line);
-            }
-            return true;
-
-        case 0x5A:
-            ClipStartLeft(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                return false;
-            }
-            ClipEndRight(line);
-            if (line.end.y > m_clipMax.y)
-            {
-                return false;
-            }
-            if (line.start.y > m_clipMax.y)
-            {
-                ClipStartBottom(line);
-            }
-            if (line.end.y < m_clipMin.y)
-            {
-                ClipEndTop(line);
-            }
-            return true;
-
-        // bottom-right
-        case 0x60:
-            ClipStartRight(line);
-            if (line.start.y > m_clipMax.y)
-            {
-                ClipStartBottom(line);
-            }
-            return true;
-
-        case 0x61:
-            ClipEndLeft(line);
-            if (line.end.y > m_clipMax.y)
-            {
-                return false;
-            }
-            ClipStartBottom(line);
-            if (line.start.x > m_clipMax.x)
-            {
-                ClipStartRight(line);
-            }
-            return true;
-
-        case 0x68:
-            ClipEndTop(line);
-            if (line.end.x > m_clipMax.x)
-            {
-                return false;
-            }
-            ClipStartRight(line);
-            if (line.start.y > m_clipMax.y)
-            {
-                ClipStartBottom(line);
-            }
-            return true;
-
-        case 0x69:
-            ClipEndLeft(line);
-            if (line.end.y > m_clipMax.y)
-            {
-                return false;
-            }
-            ClipStartRight(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                return false;
-            }
-            if (line.end.y < m_clipMin.y)
-            {
-                ClipEndTop(line);
-            }
-            if (line.start.y > m_clipMax.y)
-            {
-                ClipStartBottom(line);
-            }
-            return true;
-
-        // top
-        case 0x80:
-            ClipStartTop(line);
-            return true;
-
-        case 0x81:
-            ClipStartTop(line);
-            if (line.start.x < m_clipMin.x)
-            {
-                return false;
-            }
-            ClipEndLeft(line);
-            return true;
-
-        case 0x82:
-            ClipStartTop(line);
-            if (line.start.x > m_clipMax.x)
-            {
-                return false;
-            }
-            ClipEndRight(line);
-            return true;
-
-        case 0x84:
-            ClipStartTop(line);
-            ClipEndBottom(line);
-            return true;
-
-        case 0x85:
-            ClipStartTop(line);
-            if (line.start.x < m_clipMin.x)
-            {
-                return false;
-            }
-            ClipEndLeft(line);
-            if (line.end.y > m_clipMax.y)
-            {
-                ClipEndBottom(line);
-            }
-            return true;
-
-        case 0x86:
-            ClipStartTop(line);
-            if (line.start.x > m_clipMax.x)
-            {
-                return false;
-            }
-            ClipEndRight(line);
-            if (line.end.y > m_clipMax.y)
-            {
-                ClipEndBottom(line);
-            }
-            return true;
-
-        // top-left
-        case 0x90:
-            ClipStartLeft(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                ClipStartTop(line);
-            }
-            return true;
-
-        case 0x92:
-            ClipEndRight(line);
-            if (line.end.y < m_clipMin.y)
-            {
-                return false;
-            }
-            ClipStartTop(line);
-            if (line.start.x < m_clipMin.x)
-            {
-                ClipStartLeft(line);
-            }
-            return true;
-
-        case 0x94:
-            ClipEndBottom(line);
-            if (line.end.x < m_clipMin.x)
-            {
-                return false;
-            }
-            ClipStartLeft(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                ClipStartTop(line);
-            }
-            return true;
-
-        case 0x96:
-            ClipStartLeft(line);
-            if (line.start.y > m_clipMax.y)
-            {
-                return false;
-            }
-            ClipEndRight(line);
-            if (line.end.y < m_clipMin.y)
-            {
-                return false;
-            }
-            if (line.start.y < m_clipMin.y)
-            {
-                ClipStartTop(line);
-            }
-            if (line.end.y > m_clipMax.y)
-            {
-                ClipEndBottom(line);
-            }
-            return true;
-
-        // top-right
-        case 0xA0:
-            ClipStartRight(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                ClipStartTop(line);
-            }
-            return true;
-
-        case 0xA1:
-            ClipEndLeft(line);
-            if (line.end.y < m_clipMin.y)
-            {
-                return false;
-            }
-            ClipStartTop(line);
-            if (line.start.x > m_clipMax.x)
-            {
-                ClipStartRight(line);
-            }
-            return true;
-
-        case 0xA4:
-            ClipEndBottom(line);
-            if (line.end.x > m_clipMax.x)
-            {
-                return false;
-            }
-            ClipStartRight(line);
-            if (line.start.y < m_clipMin.y)
-            {
-                ClipStartTop(line);
-            }
-            return true;
-
-        case 0xA5:
-            ClipEndLeft(line);
-            if (line.end.y < m_clipMin.y)
-            {
-                return false;
-            }
-            ClipStartRight(line);
-            if (line.start.y > m_clipMax.y)
-            {
-                return false;
-            }
-            if (line.end.y > m_clipMax.y)
-            {
-                ClipEndBottom(line);
-            }
-            if (line.start.y < m_clipMin.y)
-            {
-                ClipStartTop(line);
-            }
-            return true;
-        }
-
-        return false;
-    }
-};
-} // namespace
-
 void
 PyViz::LineClipping(double boundsX1,
                     double boundsY1,
@@ -1577,4 +1003,5 @@
     lineY2 = line.end.y;
 }
 
+} // namespace visualizer
 } // namespace ns3
